#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include "column_functions.h"

#include "select_tree_item_callback.h"

#include "function_prototypes.h"

#include "table_functions.h"

gchar *text[5] = {"MYSQL",NULL,NULL,NULL,NULL};

void test_func(GtkWidget *widget,
                                GdkEventButton *event)
{
    GtkWidget	*main_window;
    GtkWidget   *scroll_window;
    GtkWidget	*menu;
    GtkCTree	*ctree;
    GtkCList	*clist;
    GtkCTreeNode *work;
    TABLE	*table;

    ctree = GTK_CTREE (widget);
    clist = GTK_CLIST (widget);

    main_window = gtk_widget_get_toplevel(widget);

    scroll_window = gtk_object_get_data(GTK_OBJECT(main_window),
			"scrolledwindow2");

    if(event->window == clist->clist_window)
	{
	gint x;
        gint y;
        gint row;
        gint column;

	x = event->x;
	y = event->y;

        if (!gtk_clist_get_selection_info (clist, x, y, &row, &column))
           return ;

        work = GTK_CTREE_NODE (g_list_nth (clist->row_list, row));

	if(event->button == 3)
	  {

	  table = gtk_ctree_node_get_row_data(GTK_CTREE(ctree),work);

	  if(!table || table->menu_type == NO_MENU)
		return;

	  switch(table->menu_type)
		{
		case CONNECTION_MENU:
			menu = connection_menu;
			break;
		case DATABASE_MENU:
			menu = database_menu;
			break;
		case TABLE_MENU:
			menu = table_menu;
			break;
		case FIELD_MENU:
			menu = column_menu;
			break;
		default:
			break;
		}

	  set_items(menu,work,ctree);
	  gtk_menu_popup(GTK_MENU (menu) , NULL, NULL, NULL, NULL,
			event->button,event->time);

	  }
	else if(event->button == 1)
	  {
	  }
	}

}

int
set_items(GtkWidget *menu,GtkCTreeNode *node,GtkCTree *ctree)
{
    GList	*g_l;
    GtkWidget	*menu_item;

    if(!menu)
	return 1;

    g_l = gtk_object_get_data(GTK_OBJECT(menu),"MENU_LIST");

    while(g_l)
	{
	menu_item = g_l->data;
	gtk_object_set_data(GTK_OBJECT(menu_item),"ctree",ctree);
	gtk_object_set_data(GTK_OBJECT(menu_item),"MY_DATA",node);	
	g_l = g_list_next(g_l);
	}

    return 0;
}

int
build_driver_list	(GtkWidget	*tree)
{
    DRIVER	*driver_p;
    GList	*driver_list_p = driver_list;
    GList	*g_l;
    TABLE	*login_table;
    GtkWidget	*sub_tree;
    GtkWidget	*tree_item;
    GtkWidget	*container;
    GtkCTreeNode *new_node;


    while(driver_list_p)
	{
	login_table = (TABLE *)malloc(sizeof(TABLE));

	driver_p = (DRIVER *)driver_list_p->data ;

	strcpy(login_table->name,driver_p->name);

	g_l = driver_p->fields;

	text[0] = driver_p->name;
	new_node = gtk_ctree_insert_node(GTK_CTREE(tree),
				NULL,NULL,
				text, 0,
				NULL,NULL,NULL,NULL,
				0 , 0);

	gtk_signal_connect(GTK_OBJECT(tree),
			"button_press_event",
			GTK_SIGNAL_FUNC(test_func),
			login_table);

	container =
		 create_login_screen(driver_p->fields , NULL, login_table); 

	login_table->window = container;

	gtk_object_set_data(GTK_OBJECT(container),"my_table_s",login_table);

	gtk_object_set_data(GTK_OBJECT(container),"DRIVER",driver_p);

	gtk_ctree_node_set_row_data_full(GTK_CTREE(tree),new_node,
					login_table,delete_table);

	driver_list_p = g_list_next(driver_list_p);
	}
}
