#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>


#include <dbui-defs.h>

#include <dbui-structs.h>

#include "column_functions.h"

void
delete_result_set(GList	*ls)
{
    static int i = 0;

    i = 0;
    if(ls)
	{
	if(ls->data)
		{
		delete_col_list(ls->data);
		g_list_free(ls->data);
		}
	delete_result_set(g_list_next(ls));
	i++;
	}
   
    return;
}

void
delete_col_list(GList	*ls)
{
    if(ls)
	{
	if(ls->data)
	  delete_column(ls->data);

	delete_col_list(g_list_next(ls));
  	} 
    return;
}

void
delete_column	(gpointer data)
{
    COLUMN *col;

    if(! data)
	return;

    col = (COLUMN *)data;

    if(col->value)
	free(col->value);

    free(col);
}

COLUMN *
create_new_col(char *name,TABLE *parent_table)
{
    COLUMN	*col;
    
    if(!name)
	return NULL;

    col = (COLUMN *)malloc(sizeof(COLUMN));

    strncpy(col->name,name,NAME_LENGTH);

    col->table = parent_table;

    if(parent_table)
	strncpy(col->parent_name,parent_table->name,NAME_LENGTH);
    else
	col->parent_name[0] = '\0';

    col->type = DBUI_VARCHAR;

    col->compair_type = 0;

    col->need_compair_type = 0;

    col->size = 32;

    col->value = NULL;

    col->need_quote = 1;

    col->order_by = 0;

    col->equal_col = NULL;

    return col;
}

TABLE *
create_new_table(char *name,CONNECTION *con,TABLE *parent_table)
{
    TABLE	*new_table;

    if(!name || !con)
	return NULL;

    new_table = (TABLE *)malloc(sizeof(TABLE));

    strcpy(new_table->name,name);

    new_table->limit_str = NULL;

    new_table->parent = parent_table;

    new_table->my_connect = con;

    new_table->window = NULL;

    new_table->current_pos = NULL;

    new_table->tables = NULL;

    new_table->col_set = NULL;

    new_table->current_value = NULL;

    new_table->where_value = NULL;

    new_table->result_set = NULL;

    new_table->use_where_value = 0;

    new_table->result_offset = 0;

    new_table->max_result = 0;

    new_table->result_index = 0;

    new_table->number_results = 0;

    new_table->menu_type = NO_MENU;

    new_table->my_col = NULL;

    return new_table;
}
