#include <gtk/gtk.h>

#include <stdio.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include "create_entry_field.h"

#include "table_functions.h"

GtkWidget *
create_table_ui		(GList	*g_cols,GtkWidget	*container,
			TABLE *table)
{
    int list_length;
    int i;

    /* g_table is where the soon to be created entry_field are to be placed */
    GtkWidget	*g_table;
    GtkWidget	*align;
    
    list_length = g_list_length (g_cols);

    if(! list_length)
	return NULL;

    g_table = gtk_table_new (list_length , 3 , FALSE );

    gtk_table_set_row_spacings(GTK_TABLE(g_table), 5);

    gtk_table_set_col_spacings(GTK_TABLE(g_table), 5);

    for(i = 0; i < list_length ; i++)
	{
	/* if we still have a column create an entry for it */
	if( g_cols && g_cols->data )
		create_entry_field ((COLUMN *) g_cols->data , 
				(GtkTable *) g_table, i);
	g_cols = g_list_next (g_cols);
	}

     if(table)
     	table->entry_list = gtk_object_get_data(GTK_OBJECT(g_table),"ENTRY_LIST");
 
     gtk_widget_show_all(g_table);

     align = gtk_alignment_new(0.0,0.00,1,0);

     gtk_container_add(GTK_CONTAINER(align),g_table);

     gtk_object_set_data(GTK_OBJECT(align),"my_table",g_table);

return align;
}
