#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include "column_functions.h"

#include "function_prototypes.h"

void
append_menu_item(GtkWidget *menu,char *option_string,void *func);

void
create_tree_menus()
{
    connection_menu = gtk_menu_new();
    table_menu = gtk_menu_new();
    database_menu = gtk_menu_new();
    column_menu = gtk_menu_new();

    append_menu_item(connection_menu,"Delete connection", drop_connection);

    append_menu_item(database_menu,"Rescan Database", rescan_database);

    append_menu_item(table_menu,"Rescan Table", rescan_table);

    append_menu_item(table_menu,"Result Window",result_table_window_callback);

    append_menu_item(database_menu,"Open query window",query_window_callback);


    append_menu_item(table_menu,"Add field",add_field_callback);

    append_menu_item(column_menu,"Drop Field", drop_field_callback);


    gtk_widget_show(connection_menu);
    gtk_widget_show(table_menu);
    gtk_widget_show(database_menu);
    gtk_widget_show(column_menu);
}

void
append_menu_item(GtkWidget *menu,char *option_string,void *func)
{
    GList       *g_l = NULL;
    GtkWidget   *menu_item;

    menu_item = gtk_menu_item_new_with_label(option_string);

    if(!menu_item)
        return ;

    gtk_menu_append (GTK_MENU (menu),menu_item);

    gtk_signal_connect_object (GTK_OBJECT (menu_item), "activate",
                                GTK_SIGNAL_FUNC(func),
                                (gpointer)menu_item);

    g_l = gtk_object_get_data(GTK_OBJECT(menu),"MENU_LIST");

    if(!g_l)
        {
        g_l = g_list_append(g_l,menu_item);
        gtk_object_set_data_full(GTK_OBJECT(menu),"MENU_LIST",g_l,
                        (GtkDestroyNotify)g_list_free);
        }
    else
        g_list_append(g_l,menu_item);

    gtk_object_set_data(GTK_OBJECT(menu),option_string,menu_item);

    gtk_widget_show(menu_item);
}

