#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>


#include <dbui-defs.h>

#include <dbui-structs.h>

#include "create_table_ui.h"
#include "create_tree_entry.h"
#include "select_tree_item_callback.h"
#include "table_functions.h"

#include "function_prototypes.h"

COLUMN *	get_entry_value(GtkWidget	*entry);

GList *
copy_col_list	(GList	*list)
{
    GList	*return_list = NULL;
    COLUMN	*col;
    COLUMN	*col2;

    while(list)
	{
	if(list->data)
	  {
	  col2 = (COLUMN *)list->data;
	  col = copy_column(col2);
	  if(col)
	   {
	    if(col2->value)
	     {
	      col->value = (char *)malloc(sizeof(char) * 
			      (strlen(col2->value) + 1));
	      strcpy(col->value,col2->value);
	     }
	    return_list = g_list_append(return_list,col);
	   }
	  } 
	list = g_list_next(list);
	}

    return return_list;
}

GList *
get_table_value_list	(GtkWidget	*g_table)
{
    GList	*entry_list;
    GList	*result_list = NULL;
    COLUMN	*col;

    entry_list = gtk_object_get_data (GTK_OBJECT(g_table) , "ENTRY_LIST" );

    while( entry_list )
      {
	col = get_entry_value( (GtkWidget *)entry_list->data);
	result_list = g_list_append(result_list,col);
	entry_list = g_list_next(entry_list);
      }

    return result_list;
}

COLUMN *
copy_column(COLUMN	*col)
{
    COLUMN *ret_col;

    ret_col = (COLUMN *)malloc(sizeof(COLUMN)); 

    *ret_col = *col;

    return ret_col;
}

COLUMN *
get_entry_value	(GtkWidget	*entry)
{
    COLUMN	*col;
    COLUMN	*ret_col;
    GtkWidget	*entry1;
    GtkWidget	*option;
    GtkWidget	*button;
    GtkWidget	*label;
    char	*type;
 
    col = gtk_object_get_data(GTK_OBJECT(entry) , "COLUMN");
    option = gtk_object_get_data(GTK_OBJECT(entry) , "option_menu");

    if(!col)
	return col;

    ret_col = copy_column(col);

    if(col->type != DBUI_BLOB)
	{
	entry1 = gtk_object_get_data(GTK_OBJECT(entry),"ENTRY");
    	ret_col->value = gtk_editable_get_chars(
			GTK_EDITABLE(entry1) , 0 , -1);

	}
    else
	ret_col->value = gtk_editable_get_chars(
			GTK_EDITABLE(entry), 0 , -1);

    if(col->need_compair_type && option)
	{
	button = (GtkWidget *)&GTK_OPTION_MENU(option)->button;	

	if(GTK_BIN(button)->child)
	  {
	  label = GTK_BIN(button)->child;

	  gtk_label_get (GTK_LABEL (label),&type);
	
	  if(strcmp(type,DBUI_LIKE_STRING) == 0)
		ret_col->compair_type = DBUI_LIKE;
	  else if(strcmp(type,DBUI_EQUAL_STRING) == 0)
                ret_col->compair_type = DBUI_EQUAL;
          else if(strcmp(type,DBUI_GRT_STRING) == 0)
                ret_col->compair_type = DBUI_GRT;
          else if(strcmp(type,DBUI_LT_STRING) == 0)
                ret_col->compair_type = DBUI_LT;
          else 
                ret_col->compair_type = DBUI_EQUAL;

	  }
	}
    return ret_col;
}

void
go_to_record_callback(GtkEditable *entry,gpointer data)
{
    char	*value;
    GtkWidget	*scroll_window = data;
    GtkWidget	*align;
    GtkWidget	*g_table;
    TABLE	*my_table;
    int		record_num = 0;

    value = gtk_editable_get_chars(entry,0,-1);

    if(value)
	{
	record_num = strtol(value,NULL,10);
	if(record_num > 0)
	  record_num -= 1;
	g_free(value);
	}

    if(GTK_BIN(GTK_BIN(scroll_window)->child)->child)
        {
        align = GTK_BIN(GTK_BIN(scroll_window)->child)->child;

        g_table = gtk_object_get_data(GTK_OBJECT(align),"my_table");

        }

    if(g_table)
	{
	my_table = gtk_object_get_data(GTK_OBJECT(g_table),"TABLE");

	if(my_table && my_table->result_set)
	  {
	  set_result_set_index(g_table,my_table->result_set,record_num); 
	  }
	}
}

void
set_result_set_index(GtkWidget *g_table,GList *result_set,int result_index)
{
    GList	*nth;
    TABLE	*table;
    GtkWidget	*main_window;
    GtkWidget	*label;
    char	buffer[1024];

    if(!g_table || !result_set || result_index < 0)
	return;

    table = gtk_object_get_data(GTK_OBJECT(g_table),"TABLE");

    nth = g_list_nth(result_set,result_index);

    if(!nth)
	{
	set_entry_list(g_table,result_set->data);
	result_index = 1;
	table->current_pos = result_set;
	}
    else
	{
	set_entry_list(g_table,nth->data);
	table->current_pos = nth;
	result_index++;
	}

    bzero(buffer,1024); 

    snprintf(buffer,1024,"Number: %i/%i",result_index,
		table->number_results);

    table->result_index = result_index;
    main_window = gtk_widget_get_toplevel(GTK_WIDGET(g_table));

    label = gtk_object_get_data(GTK_OBJECT(main_window),"result_label");

    if(label)
	gtk_label_set_text(GTK_LABEL(label),buffer);

    return;
}

void
set_result_set_next(GtkWidget *g_table)
{
    GList	*cur_pos;
    TABLE	*table;
    GtkWidget	*main_window;
    GtkWidget	*label;
    char	buffer[1024];


    if(!g_table)
		return;

    table = gtk_object_get_data(GTK_OBJECT(g_table),"TABLE");

    if(!table || !table->result_set)
	return;

    cur_pos = table->current_pos;

    if(!cur_pos)
	{
	table->result_index = 1;
	cur_pos = table->result_set;
	}
    else if(!g_list_next(cur_pos))
	{
	table->result_index = 1;
	cur_pos = table->result_set;
	}
    else
	{
	table->result_index++;
    	cur_pos = g_list_next(cur_pos);
	}

    if(cur_pos)
	{
	set_entry_list(g_table,cur_pos->data);
 	table->current_pos = cur_pos;	
	}

    bzero(buffer,1024);

    snprintf(buffer,1024,"Number: %i/%i",
	table->result_index,table->number_results);

    main_window = gtk_widget_get_toplevel(GTK_WIDGET(g_table));
   
    label = gtk_object_get_data(GTK_OBJECT(main_window),"result_label");
   
    if(label)
        gtk_label_set_text(GTK_LABEL(label),buffer);
   
    return;

}

void    
set_result_set_prev(GtkWidget *g_table)
{
    GList       *cur_pos;
    TABLE       *table;
    GtkWidget   *main_window;
    GtkWidget   *label;
    char        buffer[1024];
 
    
    if(!g_table)
                return;

    table = gtk_object_get_data(GTK_OBJECT(g_table),"TABLE");

    if(!table || !table->result_set)
        return;

    cur_pos = table->current_pos;

    if(!cur_pos)
	{
	table->result_index = 1;
	cur_pos = table->result_set;
	}
    else if(!g_list_previous(cur_pos))
	{
	cur_pos = g_list_last(table->result_set);
	table->result_index = g_list_length(table->result_set);
	}
    else
	{
	table->result_index--;
    	cur_pos = g_list_previous(cur_pos);
	}
    
    if(cur_pos) 
        {
        set_entry_list(g_table,cur_pos->data);
        table->current_pos = cur_pos;
        }

    bzero(buffer,1024);

    snprintf(buffer,1024,"Number: %i/%i",
        table->result_index,table->number_results);

    main_window = gtk_widget_get_toplevel(GTK_WIDGET(g_table));
  
    label = gtk_object_get_data(GTK_OBJECT(main_window),"result_label");
  
    if(label)
        gtk_label_set_text(GTK_LABEL(label),buffer);
  
    return;

}



void
set_entry_list(GtkWidget *g_table,GList *result_list)
{
    GtkWidget 	*entry_field;
    GList	*entry_list = NULL;
    GList	*g_l = NULL;
    GList	*copy = NULL;
    COLUMN	*col = NULL;
    COLUMN	*res_col = NULL;
    int		keep_going = 1;

    entry_list = gtk_object_get_data(GTK_OBJECT(g_table),"ENTRY_LIST");

    copy = g_list_copy(result_list);

    while(entry_list)
	{
	keep_going = 1;
	g_l = copy;
	entry_field = entry_list->data;
	if(entry_field)
		col = gtk_object_get_data(GTK_OBJECT(entry_field),"COLUMN");
	
	while(keep_going && g_l)
	  {
	  res_col = g_l->data;
	  if(col && res_col && !strcmp(col->name,res_col->name) )
	    {
	    set_entry_value(entry_field,res_col);
	    keep_going = 0;
	    copy = g_list_remove(copy,res_col);
	    g_l = copy;
	    }
	  g_l = g_list_next(g_l);
	  }

	if(keep_going && entry_field)
	  clear_entry_value(entry_field); 

	entry_list = g_list_next(entry_list);
	}

     g_list_free(copy);
     return;
}

COLUMN *
set_entry_value (GtkWidget	*entry,COLUMN	*col)
{
    gint	pos = 0;
    GtkWidget	*entry1;
    char	*value = "\0";

    if( col )
	{
	  if(col->value)
		value = col->value;

	  if(col->type != DBUI_BLOB)
	  {
	  entry1 = gtk_object_get_data(GTK_OBJECT(entry),"ENTRY");
	  gtk_entry_set_text(GTK_ENTRY(entry1),value);
	  }
	  else
	  {
	  gtk_editable_delete_text(GTK_EDITABLE(entry),0,-1);
	  gtk_editable_insert_text(GTK_EDITABLE(entry),
				col->value,
				strlen(value),
				&pos);
	  }
	return col;
	}

    return NULL;
}


void
clear_entry_value(GtkWidget	*entry)
{
    COLUMN	*col;
    GtkWidget	*entry_field;

    col = gtk_object_get_data(GTK_OBJECT(entry),"COLUMN");
    entry_field = gtk_object_get_data(GTK_OBJECT(entry),"ENTRY");

    if(!col || col->type == DBUI_BLOB )
    	gtk_editable_delete_text(GTK_EDITABLE(entry),0,-1);
    else if(entry_field)
	gtk_entry_set_text(GTK_ENTRY(entry_field),"\0");
}

TABLE *
get_cols_database(COLUMN	*col)
{
    if(col && col->table && col->table->parent )
	return col->table->parent;

    return NULL;
}
