GList	*driver_list;

/* Menus */
GtkWidget *connection_menu;
GtkWidget *database_menu;
GtkWidget *table_menu;
GtkWidget *column_menu;

int	PROMPT;

struct dbui_button_entry_combo
{
    GtkWidget	*entry;
    GtkWidget	*hbox;
    GtkWidget	*button;
    GtkWidget	*popup_menu;
};
typedef struct dbui_button_entry_combo DBUI_COMBO_ENTRY;

struct connection
{
    struct driver *driver_p;
    void	*handle;
    char	name[NAME_LENGTH];
    GList	*databases;
    GList	*cols;
    int		port;
};
typedef struct connection CONNECTION;

struct table
{
    struct table *parent;
    CONNECTION  *my_connect;
    char        name[NAME_LENGTH];
    char	*limit_str;
    int         result_offset;
    int         max_result;
    int         result_index;
    int         number_results;
    /* Turn this on if you want to use where_value */
    int		use_where_value;
    int		menu_type;
    GList	*entry_list;
    GList	*current_pos;
    GList       *result_set;
    GList       *col_set;
    /* This is where I should put the current value list */
    GList       *current_value;

    /* Mental note: this is where I should put the where values */
    /* if the update,search,delete in a set rather then current value */
    /* for searches it should use current value over set value */

    GList	*where_value;

    GList       *tables;
    GtkWidget   *window;
    struct column *my_col;
};
typedef struct table TABLE;


struct driver
{
    char        name[NAME_LENGTH];
    GList       *fields;

    CONNECTION  *(*login)(GList *fields);
    void	(*free_connection)(CONNECTION *connect);
    GList	*(*build_databases)(CONNECTION *connect);
    void	(*build_database)(TABLE	*table);
    void	(*build_table)(TABLE	*table);
    GList	*(*exec_search)(TABLE *table);
    GList	*(*exec_insert)(TABLE *table);
    GList	*(*exec_delete)(TABLE *table);
    GList	*(*exec_update)(TABLE *table);
    GList	*(*exec_query)(TABLE *database,TABLE *table,char *query);
};
typedef struct driver DRIVER;

struct column
{
    TABLE	*table;
    char	name[NAME_LENGTH];
    char	parent_name[NAME_LENGTH];
    DBUI_TYPE 	type;
    int		compair_type;
    int		need_compair_type;
    int		need_quote;
    int		size;
    int		order_by;
    struct column *equal_col;
    char	*value;
};
typedef struct column COLUMN;

struct _clist_request
{
    int		type;
    void	*requester;
    void	*spare1;
    void	*spare2;
};
typedef struct _clist_request CLIST_REQUEST;
