#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include <mysql/mysql.h>

#include <mysql-prototypes.h>

#include "../gui/function_prototypes.h"

GList *
mysql_build_databases(CONNECTION	*connect)
{
    MYSQL_RES	*result_set;
    MYSQL_ROW	row;
    GList	*databases = NULL;
    GList	*g_l;
    TABLE	*database;
    int		num_rows;
    int		i;

    result_set = mysql_list_dbs((MYSQL *)connect->handle,NULL);

    num_rows = mysql_num_rows(result_set);

    for(i = 0; i < num_rows ; i ++)
	{
	row = mysql_fetch_row(result_set);

	database = create_new_table(row[0],connect,NULL);

	database->menu_type = DATABASE_MENU;

	databases = g_list_append(databases,database);
	} 

    mysql_free_result(result_set);

    g_l = databases;

    while(g_l)
	{
	mysql_build_database(g_l->data);

	g_l = g_list_next(g_l);
	}

    return databases;
}
