#include <gtk/gtk.h>
 
#include <stdio.h>
#include <string.h>
    
#include <dbui-defs.h>
    
#include <dbui-structs.h>

#include <dbui-prototypes.h>
    
#include <mysql/mysql.h>
    
#include <mysql-prototypes.h>

#include "../gui/function_prototypes.h"

void
mysql_build_table(TABLE	*table)
{
    MYSQL_RES	*result_set;
    MYSQL_ROW	row;
    MYSQL_FIELD *fields;
    CONNECTION	*connect;
    TABLE	*database;
    TABLE	*col_tab;
    COLUMN	*col;
    GList	*table_cols = NULL;
    GList	*col_set = NULL;
    char	show_query[2048];
    char	full_name[NAME_LENGTH];
    int		num_rows;
    int		i;

    connect = table->my_connect;

    database = table->parent;

    bzero(show_query,2048);

    snprintf(show_query,2048,"select * from %s limit 1",table->name);

    if(! mysql_select_db((MYSQL *)connect->handle,database->name) )
	{
	if( mysql_real_query((MYSQL *)connect->handle,show_query,
			strlen(show_query)) )
	  {
	  printf("error: %s \n",mysql_error((MYSQL *)connect->handle) );
	  fflush(stdout);

	  return;
	  }

	result_set = mysql_store_result((MYSQL *)connect->handle);

	if(!result_set)
	  {
	  return;
	  }	

	num_rows = mysql_num_fields(result_set);

	fields = mysql_fetch_fields(result_set);

	for(i = 0 ; i < num_rows ; i++)
		{
		bzero(full_name,NAME_LENGTH);

		snprintf(full_name,NAME_LENGTH,"%s.%s",table->name,
			fields[i].name);

		col_tab = create_new_table(full_name,connect,table);

		col_tab->menu_type = FIELD_MENU;

		col_tab->parent = table;
		
		col = create_new_col(fields[i].name,table);

		if(fields[i].table)
		   strncpy(col->parent_name,fields[i].table,NAME_LENGTH);

		col_tab->my_col = col;

		col->size = fields[i].length;

		col->type = mysql_change_type_to_dbui(fields[i].type );

		col->need_compair_type = 1;

		col_set = g_list_append(col_set,col);

		table_cols = g_list_append(table_cols,col_tab);
		}

	table->tables = table_cols;

        table->col_set = col_set;
    
        mysql_free_result(result_set);

	}

}
