#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include <libpq-fe.h>

#include <postgres-prototypes.h>

void
postgres_build_database(TABLE	*database)
{
    CONNECTION	*connect;
    PGresult	*result;
    GList	*g_l;
    TABLE	*table;
    char	query[2048];
    char	*value;
    int		num_rows;
    int		i;

    connect = database->my_connect;

    sprintf(query,"select relname from pg_class, pg_user where relowner = usesysid and (relkind = 'r' or relkind = 'S') and relname !~ '^pg_'");

    result = PQexec(connect->handle,query);

    if(result)
	{
	num_rows = PQntuples(result);

	for(i = 0 ; i < num_rows; i++)
	  {
	  value = PQgetvalue(result,i,0);

	  table = (TABLE *)create_new_table(value,connect,database);

	  table->my_connect = connect;

          table->menu_type = TABLE_MENU;

          database->tables = g_list_append(database->tables,table);

	  }

	PQclear(result);
	}

    g_l = database->tables;

    while(g_l)
	{
	
	postgres_build_table(g_l->data);
	
	g_l = g_list_next(g_l);
	}

}
