#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include <libpq-fe.h>

#include <postgres-prototypes.h>


CONNECTION *
postgres_login(GList	*fields)
{
    PGconn	*pg_handle = NULL;
    CONNECTION	*connect = NULL;
    COLUMN	*col = NULL;
    GList	*g_p = NULL;
    char	*hostname = NULL;
    char	*username = NULL;
    char	*password = NULL;
    char	*database = NULL;
    char	*port = NULL;
    int		name_len = 0;

    connect = (CONNECTION *)malloc(sizeof(CONNECTION));

    connect->cols = fields;

    g_p = fields;

    while(g_p)
	{
	col = (COLUMN *)g_p->data;

	if(!strncmp(col->name,"Hostname",strlen("Hostname")))
	  {
	  hostname = col->value;

	  }
	else if(!strncmp(col->name,"Username",strlen("Username")))
	  {
	  username = col->value;
	  }
	else if(!strncmp(col->name,"Password",strlen("Password")))
          {
          password = col->value;
          }
	else if(!strncmp(col->name,"Database",strlen("Database")))
          {
          database = col->value;
          }
	else if(!strncmp(col->name,"Port",strlen("Port")))
          {
          port = col->value;
          }
	g_p = g_list_next(g_p);
	}

    bzero(connect->name,NAME_LENGTH);

    if(username && hostname)
      {
	snprintf(connect->name,NAME_LENGTH / 2,"%s",username);
	name_len = strlen(connect->name);
	snprintf(connect->name + name_len ,NAME_LENGTH /2 ,
				"@%s",hostname);
      }

    pg_handle = PQsetdbLogin(hostname,port,NULL,NULL,database,username,password);
    if(!pg_handle)
	{
	printf("Could not log in\n");
	fflush(stdout);
	g_list_free(connect->cols);

	free(connect);
	return NULL;
	}

    if(PQstatus(pg_handle) != CONNECTION_OK)
	{
	printf("Error logging in: %s\n",PQerrorMessage(pg_handle));	
	PQfinish(pg_handle);

	g_list_free(connect->cols);
	free(connect);
	return NULL;
	}

    connect->handle = pg_handle;

    return connect;
}
