#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include <dbui-sql-proto.h>

#define DELETE_STATEMENT "delete from %s "

char *
build_delete_query(TABLE	*table)
{
    GList	*g_l = NULL;
    char	*query = NULL;
    char	*table_str = NULL;
    char	*col_str = NULL;
    char	*value_str = NULL;
    char	**value_list = NULL;
    COLUMN	*col = NULL;
    int		query_length = 0;
    int		col_list_len = 0;
    int		num_col_list = 0;
    int		value_list_len = 0;
    int		list_len = 0;
    int		total_len = 0;
    int		i = 0;
    int		num_value_list = 0;

    if(!table || !table->current_value)
	return NULL;

    table_str = get_col_table_names(table);

    if(!table_str )
	return NULL;

    if(strchr(table_str,','))
	{
	free(table_str);
	return NULL;
	} 

    value_str = get_col_where_clause(table);

    if(table_str )
	{
	query_length = strlen(DELETE_STATEMENT);
	query_length += strlen(table_str);

	if(value_str)
		query_length += strlen(value_str) ;

	query = (char *)calloc(query_length + 1, sizeof(char));

	snprintf(query,query_length,DELETE_STATEMENT,table_str);
       
	if(value_str)
	  {
	  query_length = strlen(query);
	  memcpy(query + query_length,value_str , strlen(value_str));
	  }

	}

    for(i = 0; i < list_len ; i++)
	{
	if(value_list[i])
	  free(value_list[i]);
	}

    free(value_list);

    return query;
}
