#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include <dbui-sql-proto.h>

#define INSERT_STATEMENT "insert into %s (%s) values (%s)"

char *
build_insert_query(TABLE	*table)
{
    GList	*g_l = NULL;
    char	*query = NULL;
    char	*table_str = NULL;
    char	*col_str = NULL;
    char	*value_str = NULL;
    char	**value_list = NULL;
    char	**col_list = NULL;
    COLUMN	*col = NULL;
    int		query_length = 0;
    int		col_list_len = 0;
    int		num_col_list = 0;
    int		value_list_len = 0;
    int		list_len = 0;
    int		total_len = 0;
    int		i = 0;
    int		num_value_list = 0;

    if(!table || !table->current_value)
	return NULL;

    table_str = get_col_table_names(table);

    if(!table_str )
	return NULL;

    if(strchr(table_str,','))
	{
	free(table_str);
	return NULL;
	} 

    list_len =  g_list_length(table->current_value);

    value_list = (char **)malloc(list_len * sizeof(char *));
    col_list = (char **)malloc(list_len * sizeof(char *));

    g_l = table->current_value;

    for (i = 0; i < list_len ; i++)
	{

	value_list[i] = NULL;
	col_list[i] = NULL;

	if(g_l)
	  {
	  col = g_l->data;	
	  if(col)
	    {
	    value_list[i] = get_col_value(col);

	    if(value_list[i])
		{
		col_list[i] = col->name;
		num_col_list += 1;
		col_list_len += strlen(col_list[i]);
		num_value_list += 1;
		value_list_len += strlen(value_list[i]);
		}

	    }

	  g_l = g_list_next(g_l);
	  }
	}

    value_str = get_con_cat_list(value_list," , ",list_len,
							value_list_len);

    col_str = get_con_cat_list(col_list," , ",list_len,col_list_len);

    if(value_str && col_str)
	{
	query_length = strlen(INSERT_STATEMENT);
	query_length += strlen(value_str) + strlen(col_str);
	query_length += strlen(table_str);
	query = (char *)calloc(query_length , sizeof(char));

	snprintf(query,query_length,INSERT_STATEMENT,table_str,
			col_str,value_str);
	}

    for(i = 0; i < list_len ; i++)
	{
	if(value_list[i])
	  free(value_list[i]);
	}

    free(col_list);
    free(value_list);

    return query;
}
