#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include <dbui-sql-proto.h>

#define UPDATE_STATEMENT "update %s set %s "

char *
build_update_query(TABLE	*table)
{
    GList	*g_l = NULL;
    GList	*g_l2 = NULL;
    char	*query = NULL;
    char	*table_str = NULL;
    char	*col_str = NULL;
    char	*value_str = NULL;
    char	*where_str = NULL;
    char	**where_list = NULL;
    char	**value_list = NULL;
    COLUMN	*col = NULL;
    COLUMN	*col2 = NULL;
    int		query_length = 0;
    int		where_list_len = 0;
    int		num_where_list = 0;
    int		value_list_len = 0;
    int		list_len = 0;
    int		total_len = 0;
    int		i = 0;
    int		num_value_list = 0;

    if(!table || !table->current_value || !table->result_set)
	return NULL;

    table_str = get_col_table_names(table);

    if(!table_str )
	return NULL;

    if(strchr(table_str,','))
	{
	free(table_str);
	return NULL;
	} 

    if(table->where_value && table->use_where_value)
	g_l2 = table->where_value;
    else	
	{
	g_l2 = g_list_nth(table->result_set,table->result_index - 1);
	if(g_l2 && g_l2->data)	
	  g_l2 = g_l2->data;
	}
 
    g_l = table->current_value;

    if(!g_l || !g_l2)
	{
	free(value_list);
	return NULL;
	}

    list_len =  g_list_length(g_l2);
    if(list_len < g_list_length(g_l))
	list_len =  g_list_length(g_l);

    value_list = (char **)malloc(list_len * sizeof(char *));
    where_list = (char **)malloc(list_len * sizeof(char *));

    if(!value_list || !where_list)
        return NULL;

    
    for (i = 0; i < list_len ; i++)
	{
	value_list[i] = NULL;
	where_list[i] = NULL;
	if(g_l )
	  {
	  col = g_l->data;	
	  if(col)
	    {
	    value_list[i] = get_col_equal_string(col," = ",FALSE);
	    if(value_list[i])
		{
		num_value_list += 1;
		value_list_len += strlen(value_list[i]);
		}
	    }
	  g_l = g_list_next(g_l);
	  }
	if(g_l2)
	  {
	  col2 = g_l2->data;
	  if(col2)
	    {
	  	where_list[i] = get_col_equal_type_string(col2);
	  	if(where_list[i])
			{
                	num_where_list += 1;
                	where_list_len += strlen(where_list[i]);
	
                	}
	    }
	  g_l2 = g_list_next(g_l2);
	  }
	}
    
    value_str = get_con_cat_list(value_list," , ",list_len,
							value_list_len);

    if(num_where_list)
    	where_str = get_con_cat_list(where_list," and ",list_len,
							where_list_len);

    if(value_str )
	{
	query_length = strlen(UPDATE_STATEMENT);
	query_length += strlen(table_str) + strlen(value_str);

	if(num_where_list)
		query_length += strlen(where_str) + strlen(" WHERE ");

	query = (char *)calloc(query_length +1, sizeof(char));

	snprintf(query,query_length,UPDATE_STATEMENT,table_str,value_str);

	free(table_str);
	free(value_str);

	if(num_where_list)
	  {
          memcpy(query + strlen(query)," WHERE ",strlen(" WHERE "));
          query_length = strlen(query);
          memcpy(query + query_length,where_str,strlen(where_str));
	  free(where_str);
	  }
	}

    for(i = 0; i < list_len ; i++)
	{
	if(where_list[i])
	  free(where_list[i]);
	if(value_list[i])
	  free(value_list[i]);
	}

    free(where_list);
    free(value_list);

    return query;
}
